// ----------------------------------------------------------------------
// Setup information
// ----------------------------------------------------------------------

// Global variables
// ----------------

var DEBUG = false;

// First hour of schedule display
var hourstart;

// Setup channel names and IDs
// ----------------------------

var channels = [];
var channel_by_id = {};

// Register a channel
function channel(short_name, id, long_name)
{
	var c = new Channel();
	c.long_name = long_name;
	c.short_name = short_name;
	c.id = id;
	
	channels.push(c);
	channel_by_id[id] = c;
	return c;
}

// Register all channels
channel('3+ Danm',  83, '3+ Danmark');
channel('3SAT   ',   1, '3SAT');
channel('ARD    ',  69, 'ARD');
channel('Aftonbl', 248, 'Aftonbladet TV');
channel('Animal ',  54, 'Animal Planet');
channel('Arte   ',  84, 'Arte');
channel('Axess  ', 247, 'Axess TV');
channel('BBC Foo', 149, 'BBC Food');
channel('BBC Pri',   2, 'BBC Prime');
channel('BBC Wor',   3, 'BBC World');
channel('Barn   ', 143, 'Barnkanalen');
channel('Big Tv ', 233, 'Big Tv');
channel('C+Fi HD', 229, 'Canal+ Film HD');
channel('C+Drama', 255, 'Canal+ Drama');	// aka
channel('C+First', 256, 'Canal+ First');	// aka
channel('C+Hits ', 257, 'Canal+ Hits');		// aka
channel('C+Cmdy ', 298, 'Canal+ Comedy');	// aka, ny
channel('C+Film3', 227, 'Canal+ Film 3');
channel('C+Sp HD', 271, 'Canal+ Sport HD');
channel('C+Spor1', 140, 'Canal+ Sport 1');
channel('C+Spor2', 258, 'Canal+ Sport 2');
channel('CNBC   ',  56, 'CNBC');
channel('CNN    ',   5, 'CNN');
channel('Canal7 ',  80, 'Canal7');
channel('Cartoon',   4, 'Cartoon Network');
channel('DR1    ',  58, 'DR1');
channel('DR2    ',  59, 'DR2');
channel('DSF    ',   8, 'DSF');
channel('Deutsch',   6, 'Deutsche Welle');
channel('Di TV  ', 231, 'Di TV');
channel('Dis Wor', 118, 'Discovery World');	// aka
channel('Dis Mix',  89, 'Discovery Mix');
channel('Dis Sci', 119, 'Discovery Science');
channel('Dis Tra', 120, 'Discovery Travel & Living');
channel('Discove',   7, 'Discovery Channel');
channel('Disney ', 147, 'Disney Channel');
channel('E!     ', 225, 'E!');
channel('ESPN CS', 196, 'ESPN Classic Sport');
channel('Eur New', 141, 'Eurosport News');
channel('Euronew', 104, 'Euronews');
channel('Eurosp2', 217, 'Eurosport 2');
channel('Eurospo',   9, 'Eurosport');
channel('Extreme',  67, 'Extreme sports');
channel('FST    ', 219, 'FST');
channel('Fashion',  82, 'Fashion TV');
channel('Fight+ ', 245, 'Fight+');
channel('God Cha', 111, 'God Channel');
channel('Gtebor', 239, 'Kanal Lokal Gteborg');
channel('HRT1   ',  50, 'HRT1');
channel('Hallmar',  13, 'Hallmark');
channel('Hustler', 175, 'Hustler TV');
channel('Jetix  ',  60, 'Jetix');
channel('Kabel 1', 113, 'Kabel 1');
channel('Kanal 5',  10, 'Kanal 5');
channel('Kanal 9', 246, 'Kanal 9')
channel('Kanal5D', 103, 'Kanal 5 Danmark')
channel('Kunskap', 213, 'Kunskapskanalen');
channel('MDR    ',  91, 'MDR');
channel('MTV    ',  14, 'MTV');
channel('MTV2   ',  74, 'MTV2');
channel('MTV3   ',  39, 'MTV3');
channel('Manches', 193, 'Manchester United TV');
channel('Mezzo  ',  46, 'Mezzo');
channel('NRK1   ',  72, 'NRK1');
channel('NRK2   ',  63, 'NRK2');
channel('Nat Geo',  48, 'National Geographic');
channel('Nelonen', 189, 'Nelonen');
channel('Nickleo',  45, 'Nickleodeon');
channel('ORT Int', 139, 'ORT Int');
// aka channel('One Tel', 246, 'One Television');
channel('PRO 7  ',  98, 'PRO 7');
channel('Pink Pl', 109, 'Pink Plus');
channel('Playboy', 223, 'Playboy TV');
channel('RTL    ',  16, 'RTL');
channel('RTL 2  ',  15, 'RTL 2');
channel('Rai Due',  65, 'Rai Due');
channel('Rai Uno',  64, 'Rai Uno');
channel('Reality', 117, 'Reality TV');
channel('SAT1   ',  17, 'SAT1');
channel('SVT Eur', 100, 'SVT Europa');
channel('SVT1   ',  21, 'SVT 1');
channel('SVT2   ',  22, 'SVT 2');
channel('SVT24  ', 101, 'SVT24');
channel('Showtim', 214, 'Showtime');
channel('Silver ', 241, 'Silver');
channel('Sky New',  18, 'Sky News');
channel('Skne  ', 244, 'Kanal Lokal Skne');
channel('Spice  ', 110, 'Spice');
channel('Spice P', 222, 'Spice Platinum');
channel('Sport E', 218, 'Sport Expressen');
channel('Star!  ', 114, 'Star!');
channel('Stockho', 238, 'Kanal Lokal Stockholm');
channel('TCM    ',  24, 'TCM');
channel('TV Chil',  52, 'TV Chile');
channel('TV Danm', 105, 'TV Danmark');
channel('TV Finl',  29, 'TV Finland');
channel('TV Norg',  73, 'TV Norge');
channel('TV Polo',  66, 'TV Polonia');
channel('TV1000 ',  33, 'TV1000');
channel('TV1000+', 206, 'TV1000 Plus One');
channel('TV1000A', 207, 'TV1000 Action');
channel('TV1000C', 208, 'TV1000 Classic');
channel('TV1000F', 210, 'TV1000 Family');
channel('TV1000N', 209, 'TV1000 Nordic');
channel('TV2 Dan',  71, 'TV2 Danmark');
channel('TV2 Nor',  37, 'TV2 Norge');
channel('TV2 Zul', 126, 'TV2 Zulu');
channel('TV3    ',  26, 'TV3');
channel('TV3 Dan',  57, 'TV3 Danmark');
channel('TV3 Nor',  62, 'TV3 Norge');
channel('TV4    ',  27, 'TV4');
channel('TV4 Fak', 230, 'TV4 Fakta');
channel('TV4 Kom', 253, 'TV4 Komedi');		// aka, ny
channel('TV4 Fil', 176, 'TV4 Film');
channel('TV4 Spo', 275, 'TV4 Sport')
channel('TV4+   ', 142, 'TV4 Plus');
channel('TV400  ', 199, 'TV400');
channel('TV5    ',  40, 'TV5');
channel('TV6    ',  42, 'TV6');
channel('TV8    ',  43, 'TV8');
channel('TVE    ',  41, 'TVE');
channel('Toon Di', 224, 'Toon Disney');
channel('Travel ',  25, 'Travel');
channel('VH-1   ',  47, 'VH-1');
channel('Via Exp',  76, 'Viasat Explorer');
channel('Via His', 215, 'Viasat History');
channel('Via Nat',  28, 'Viasat Nature/Crime');
channel('Via Sp2', 197, 'Viasat Sport 2');
channel('Via Sp3', 198, 'Viasat Sport 3');
channel('Via Spo',  53, 'Viasat Sport');
channel('Viva   ', 106, 'Viva');
channel('Viva Pl',  85, 'Viva Plus');
channel('Vox    ', 107, 'Vox');
channel('YLE 24 ', 220, 'YLE 24');
channel('YLE TV1',  31, 'YLE TV1');
channel('YLE TV2',  36, 'YLE TV2');
channel('YLE Tee', 221, 'YLE Teema');
channel('ZDF    ',  51, 'ZDF');
channel('ZTV    ', 240, 'ZTV');
channel('ZTV Nor',  75, 'ZTV Norge');
channel('sterg', 234, 'Kanal Lokal stergtland');


channels.sort( function(a,b) {
	if (a.long_name < b.long_name) return -1;
	if (a.long_name > b.long_name) return 1;
	return 0;
})

// ----------------------------------------------------------------------
// Preferences
// ----------------------------------------------------------------------

// Keeps track of user preferences, channels to display and styles of
// programs.
function Preferences()
{
	this.styles = {};
	if (DEBUG) {
		this.channels = [21];
	} else {
		this.channels = [21, 22, 26, 27, 10, 42, 142, 89, 14];
	}
	this.load_channels();
}

// Style for specified program.
Preferences.prototype.style = function(program) {
	if (window.widget && !this.styles[program.bare_name])
		this.styles[program.bare_name] = widget.preferenceForKey(program.bare_name);
	return this.styles[program.bare_name] || "regular";
}

// Set style for program.
Preferences.prototype.set_style = function(program, s) {
	if (s == "regular")
		s = null;
	this.styles[program.bare_name] = s;
	if (window.widget)
		widget.setPreferenceForKey(s, program.bare_name);
}

// Cycle style selection for program using predefined list.
Preferences.prototype.cycle_style = function(program) {
	var style = this.style(program);
	
	if (style == "regular")
		style = "grey";
	else if (style == "grey")
		style = "yellow";
	else if (style == "yellow")
		style = "cyan";
	else if (style == "cyan")
		style = "green";
	else if (style == "green")
		style = "regular";

	this.set_style(program, style);
}

// Save channel selection in preferences.
Preferences.prototype.save_channels = function()
{
	if (window.widget)
		widget.setPreferenceForKey(this.channels.join(","), "_channels");
}

// Load channel selection from preferences.
Preferences.prototype.load_channels = function()
{
	if (window.widget) {
		var p = widget.preferenceForKey("_channels");
		if (p) {
			this.channels = p.split(",");
		}
	}
}

// Removes the channel stored at the specified index.
Preferences.prototype.remove_channel_at_index = function(index)
{
	this.channels.splice(index, 1);
	this.save_channels();
}

// Sets the channel at the specified index to the id
Preferences.prototype.set_channel_at_index_to_id = function(index, id)
{
	if (channel_by_id[id]) {
		this.channels[index] = id;
		channel_by_id[id].load();
	}
	this.save_channels();
}

// Adds a new channel to the display.
Preferences.prototype.add_channel = function(id)
{
	if (channel_by_id[id]) {
		this.channels.push(id);
		channel_by_id[id].load();
	}
	this.save_channels();
}

var preferences = new Preferences();

// ----------------------------------------------------------------------
// Utility code
// ----------------------------------------------------------------------

// mouse capture

document.captureEvents(Event.MOUSEMOVE)
document.onmousemove = mousemove;
var mouse = Object();

// Handle mouse movement, store mouse position.
function mousemove(e) 
{
	mouse.x = e.pageX;
	mouse.y = e.pageY;

	var info = document.getElementById("info");
	info.style.left = mouse.x + "px";
	info.style.top = (mouse.y + 20) + "px";
}

// Loads the web page specified by the URL, calls success(text) if the load is
// successful and failure(request) otherwise.
function load_html(url, success, failure)
{
	var request = new XMLHttpRequest();
	request.onreadystatechange = function () {
		if (request.readyState == 4) {
			if (request.status == 200) {
				success(request.responseText);
			} else {
				failure(request);
			}
		}
	}
	request.open("GET", url, true);
	request.send(null);
}

// Logs the specified text in the debug node of the document
function log(s)
{
	if (!DEBUG) {
		return;
	}
	var log = document.getElementById("log");
	var t = document.createTextNode(s);
	var p = document.createElement("p");
	p.appendChild(t);
	log.appendChild(p);
}

// ----------------------------------------------------------------------
// Data manipulation
// ----------------------------------------------------------------------

// Minute processing
// -----------------

// Returns minutes of a clock string "00:20"
function minutes(t)
{
	var match = t.match(/(\d?\d)\:(\d\d)/);
	var h = Number(match[1]);
	var m = Number(match[2]);
	if (h<5)
		return 60*(h+24)+m;
	else
		return 60*h+m;
}

// Program
// -------

// Stores data for a particular program.

Program.id = 1
Program.index = new Object();

Program.by_id = function (id)
{
	return Program.index[id];
}

function Program(channel, start, name, desc, showview, stop) 
{
	this.channel = channel;
	this.start = start;
	this.name = name
	this.desc = desc
	this.showview = showview
	this.stop = stop
	this.id = Program.id;
	this.bare_name = this.compute_bare_name();
	Program.index[Program.id] = this;
	Program.id++;
}
	
Program.prototype.duration = function() 
{
	return this.stop - this.start;
}

Program.prototype.feature = function()
{
	
	return (this.desc && this.desc.match('Regissr:')) ||
		this.name.match(/,\s*forts/);
}

Program.prototype.compute_bare_name = function()
{
	var n = this.name;
	n = n.replace(/<strong.*/i, "");	// aka
	n = n.replace(/\(R\)/, "");
	n = n.replace(/,\s*forts/, "");
	n = n.replace(/^\s*/, '')
	n = n.replace(/\s*$/, '')
	var m = n.match(/(.*:)/);
	if (m) {n = m[1];}
	return n;
}

Program.prototype.original_name = function()
{
	var m = this.desc.match(/.*\((.*)\)/)
	if (m) {return m1[1];} else {return this.bare_name;}
}

// If this is a continuation of a program, returns that programs name
// otherwise nil.

Program.prototype.cont = function()
{
	if (!name.match(/, forts$/)) {return nil;}
	var n = name;
	n = n.replace(/, forts$/, "");
	return n;
}

Program.prototype.length = function ()
{
	if (this.stop)
		return minutes(this.stop) - minutes(this.start);
	else
		return 60;	
}

// Channel
// -------

// Stores data (all the programs) for a particular channel.

function Channel() {
	this.programs = [];
};

// Load programs of this channel if needed
Channel.prototype.load = function()
{
	if (!this.programs.length)
		this.refresh();
}

// Force load programs for this channel
Channel.prototype.refresh = function()
{
	this.programs = [];
	var x = this;
	load_html("http://www.dagenstv.com/se/chart/?cha=" + this.id, function (s) {x.refresh_from_data(s)},
		function() {});
}

// Callback for refreshing data
Channel.prototype.refresh_from_data = function(data)
{
	this.programs = [];
	
	var last = null;
	var rows = data.match(/<!-- Start \d* -->(.|\r\n)*?<!-- Stop \d* -->/mg);
	for (r in rows) {
		var row = rows[r];
		row = row.replace(/<!--(.|\r\n)*?-->/mg,'')
		log(row)
		// var cols = row.match(/<td(.|\r\n)*?<\/td>/mg);
		var start, name, desc, show
		start = row.match(/<div class="tbl_lrg_event_time(_past|_active)?">\s*(\d\d:\d\d)/)
		start = start && start[2]
		name = row.match(/<div class="tbl_lrg_event_name(_past|_active)?">((.|\r\n)*?)<\/div>/)
		name = name && name[2]
		desc = row.match(/<div class="tbl_lrg_event_description(_past|_active)?">((.|\r\n)*?)<\/div>/)
		desc = desc && desc[2]
		desc = desc && desc.replace(/<strong.*strong>/,'');		// aka
		show = desc && desc.match(/\[\d+\]/) + ''
		show = show && show.replace(/\[/, '')
		show = show && show.replace(/\]/, '')
		desc = desc && desc.replace(/\[\d+\]/, '');
		desc = desc && desc.replace(/<(.|\r\n)*?>/mg, '');

		log(start + " --- " + name + " --- " + desc + " --- " + show )
		if (start && name) {
			desc = desc || "";
			var p = new Program(channel, start, name, desc, show);
			this.programs.push(p);
			if (last) {
				last.stop = start;
			}
			last = p;
		}
	}
	redraw();
}

var drawn = [];

// Draws channel programs
Channel.prototype.draw = function(index, layout)
{
	var y = layout.yoffset + index * layout.rowheight;
	var x0 = layout.xoffset - layout.minutewidth * layout.starttime;
	
	var drawarea = document.getElementById("drawarea");
	for (p in this.programs) {
		var program = this.programs[p];
		
		var start = minutes(program.start);
		var stop = start + program.length();
		
		if (stop < layout.starttime)
			continue;
		if (start > layout.stoptime)
			continue;
		
		var styles = "program"
		if (program.feature())	
			styles = styles + " feature";
		styles = styles + " " + preferences.style(program);
		
		var leftcut = false, rightcut = false;
		if (stop > layout.stoptime) {
			stop = layout.stoptime;
			styles = styles + " rightcut";
			rightcut = true;
		}
		if (start < layout.starttime) {
			start = layout.starttime;
			styles = styles + " leftcut";
			leftcut = true;
		}
		
		var t = document.createElement("div");
		
		var x = x0 + start*layout.minutewidth;
		var w = layout.minutewidth*(stop - start) - layout.shrinkbox;
		
		if (w < 10) continue;
		
		if (leftcut) {
			x = x - 15;
			w = w + 15;
		}
		
		if (rightcut) {
			w = w + 15;
		}
		
		var text = 
			//'<a href="#anyurl" onclick="cycle_style({program.id})" onmouseover="showinfo({program.id})" onmouseout="hideinfo()">	\n' +
			'<div id="{program.id}" onclick="cycle_style({program.id})" onmouseover="return showinfo({program.id})" onmouseout="return hideinfo()"	\n' +
			'	class="{styles}" style="top: {y}px; left: {x}px; width: {w}px;">	\n' +
			'	<p class="programtext">{program.name}</p>	\n' +
			'</div></a>	\n';
		text = text.replace(/\{program.id\}/g, program.id).replace("{styles}", styles).replace("{y}", y).replace("{x}", x).replace("{w}", w).
			replace("{program.name}", program.name);
		t.innerHTML = text;
		drawarea.appendChild(t);
		
		function bgbox(x,y,w,h) {
			var t = document.createElement("div");
			t.innerHTML = '<div class="bg" style = "top: {y}px; left: {x}px; width: {w}px; height: {h}px"></div>'.
				replace("{x}", x).replace("{y}", y).replace("{w}", w).replace("{h}", h);
			drawarea.appendChild(t);
		}
		
		if (leftcut) {
			bgbox(x,y,15,5);
			bgbox(x,y+12,15,5);
		}
		
		if (rightcut) {
			bgbox(x+w-15,y,15,5);
			bgbox(x+w-15,y+12,15,5);
		}
		
		drawn.push(program.id);
	}
}

// Shows info for specified program
function showinfo(id)
{	
	var info = document.getElementById("info");
	info.style.display = "block";
	
	var program = Program.by_id(id);
	var infotitle = document.getElementById("infotitle");
	infotitle.innerHTML = program.start + " " + program.name;
	var infodesc = document.getElementById("infodesc");
	infodesc.innerHTML = program.desc;
	return true;
}

// Hides info for program
function hideinfo()
{
	var info = document.getElementById("info");
	info.style.display = "none";
}

// Cycles style for program
function cycle_style(id)
{
	var program = Program.by_id(id);
	preferences.cycle_style(program);
	update_style(id);
	
	for (i in drawn) {
		var p2 = Program.by_id(drawn[i]);
		if (p2.bare_name == program.bare_name)
			update_style(drawn[i]);
	}
}

// Updates style for id
function update_style(id)
{
	var program = Program.by_id(id);
	
	var styles = "program"
	if (program.feature())	
		styles = styles + " feature";
	styles = styles + " " + preferences.style(program);
	var start = minutes(program.start);
	var stop = start + program.length();
	if (stop > layout.stoptime) 
		styles = styles + " rightcut";
	if (start < layout.starttime)
		styles = styles + " leftcut";

	var element = document.getElementById(id);
	element.className = styles;
}


// ----------------------------------------------------------------------
// Widget initialization code
// ----------------------------------------------------------------------

function setup()
{
	if (window.widget) {
		widget.onhide = onhide;
		widget.onshow = onshow;
	}
	onshow();
}

// ----------------------------------------------------------------------
// Main widget code
// ----------------------------------------------------------------------

var layout = new Object();

// Adds an item to the draw area.
function add_item(s)
{
	var drawarea = document.getElementById("drawarea");
	var t = document.createElement("div");
	t.innerHTML = s;
	drawarea.appendChild(t);
}

// Draws clock ticks.
function draw_clock(layout)
{
	var y = layout.yoffset - 30;
	var x0 = layout.xoffset - layout.minutewidth * layout.starttime;
	
	for(hour = 0; hour<=23; ++hour) {
		var m = minutes(hour + ":00")
		if (m >= layout.starttime && m <= layout.stoptime) {
			var x = x0 + m*layout.minutewidth;
				
			add_item(
				'<div class="clock" style="left: {left}px; top: {top}px;"><p align=center>{time}</p></div>'.
					replace("{left}", x-50-2).replace("{top}", y).replace("{time}", hour + ":00")
				);
				
			add_item(
				'<div class="divider" style="left: {left}px; top: {top}px; height: {height}px;"></div>'.
					replace("{left}", x-2).replace("{top}", y + 22).replace("{height}", preferences.channels.length * layout.rowheight + 10)
			);
		}
	}
	
	var today = new Date();
	var hour = today.getHours();
	var m = minutes(hour + ":00") + today.getMinutes()
	var x = x0 + m*layout.minutewidth;
	add_item(
		'<div class="divider now" style="left: {left}px; top: {top}px; height: {height}px;"></div>'.
			replace("{left}", x).replace("{top}", y + 22).replace("{height}", preferences.channels.length * layout.rowheight + 10)
	);
}

// Draws channels.
function draw_channels(layout)
{
	var x = layout.xoffset - 60;
	
	for (k in preferences.channels) {
		var y = layout.yoffset + k * layout.rowheight;
		var channel = channel_by_id[preferences.channels[k]];
		
		add_item(
			'<div class="channel" style="left: {x}px; top: {y}px;">{channel.short_name}</div>' .
				replace(/\{(.*?)\}/g, function (s) {return eval(s);} )
		);
		
		var selectx = x-10;
		
		var select_menu = '<select onchange="channel_select({k}, this);" ' +
			'	style="position: absolute; width: 70px; height: 20px; left: {selectx}px; top: {y}px; opacity: 0;"> ';
		select_menu += '<option value="remove">Remove</option> ';
		select_menu += '<option value="none"></option>';
		
		for (sel_k in channels) {
			var sel_channel = channels[sel_k];
			if (sel_channel == channel) {
				select_menu += '<option value="{sel_channel.id}" selected="true">{sel_channel.long_name}</option>'.
					replace(/\{(.*?)\}/g, eval )
			} else {
				select_menu += '<option value="{sel_channel.id}">{sel_channel.long_name}</option> '.
					replace(/\{(.*?)\}/g, eval )
			}
		}
		select_menu += '<option value="none"></option>';
		select_menu += '<option value="remove">Remove</option> ';		
		select_menu += "</select>"
		
		add_item(select_menu . replace(/\{(.*?)\}/g, eval));
	}
	
	var y = 40+20*preferences.channels.length;
	var add_menu = '<select onchange="add_channel(this);" ' +
		'	style="position: absolute; width: 70px; height: 40px; left: -10px; top: {y}px; z-index: 10; opacity: 0;"> ';
	add_menu += '<option value="">Add</option> ';
	add_menu += '<option value=""></option> ';
	for (sel_k in channels) {
		var sel_channel = channels[sel_k];
		add_menu += '<option value="{sel_channel.id}">{sel_channel.long_name}</option> '.
			replace(/\{(.*?)\}/g, eval )
	}
	add_menu += "</select>"

	add_item(add_menu . replace(/\{(.*?)\}/g, eval));
	
}

// Selects channel at index.
function channel_select(index, elem)
{
	var value = elem.options[elem.selectedIndex].value;
	if (value == "remove")
		preferences.remove_channel_at_index(index);
	else
		preferences.set_channel_at_index_to_id(index, parseInt(value));
	redraw();
}

// Adds channel.
function add_channel(elem)
{
	var value = elem.options[elem.selectedIndex].value;
	preferences.add_channel(parseInt(value));
	redraw();
}

// Resizes layout.
function resize(layout)
{
	var rows = preferences.channels.length;
	
	var drawarea_height = 39 + rows * layout.rowheight;
	var bottom_top = drawarea_height + 6;
	
	var drawarea = document.getElementById("drawarea");
	drawarea.style.height = drawarea_height + "px";
	var bottom = document.getElementById("bottom");
	bottom.style.top = bottom_top + "px";
	var info = document.getElementById("info");
	
	var button_top = 55 + rows * layout.rowheight;
	document.getElementById("left").style.top = button_top + "px";
	document.getElementById("right").style.top = button_top + "px";
	document.getElementById("tv").style.top = button_top + "px";
	
	// width and height of widget must have room for pop-up info window
	var width = 946;
	var height = bottom_top + 83 + 250;
		
	if (window.widget)
		window.resizeTo(width, height);
	return true;
}

// Click on left button.
function clickleft()
{
	hourstart -= 2;
	if (hourstart<0) hourstart+=24;
	redraw();
}

// Click on right button.
function clickright()
{
	hourstart += 2;
	if (hourstart >= 24) hourstart-=24;
	redraw();
}
	
// Redraw data.
function redraw()
{
	var drawarea = document.getElementById("drawarea");
	drawarea.innerHTML = '';
		
	layout.xoffset = 70;
	layout.yoffset = 30;
	layout.rowheight = 20;
	layout.minutewidth = 3;
	layout.shrinkbox = 3;
	layout.starttime = minutes(hourstart + ":00");
	layout.stoptime = layout.starttime + 180;
	resize(layout);	
	
	draw_clock(layout);
	drawn = [];
	for (k in preferences.channels) {
		var channel = channel_by_id[preferences.channels[k]];
		channel.draw(k, layout);
	}
	draw_channels(layout);
}

// Refreshes data.
var last_day;

function onshow()
{
	var today = new Date();
	hourstart = today.getHours();
	var day = today.getDay();
	if (hourstart < 5)
		day = day - 1;
	redraw();
	
	// should refresh if the day has changed...
	for (k in preferences.channels) {
		if (day == last_day)
			channel_by_id[preferences.channels[k]].load();
		else
			channel_by_id[preferences.channels[k]].refresh();
	}
	
	last_day = day;
}

function onhide()
{
}